package p03_if;

import java.util.Random;

public class TeoriaIf {

    public static void main(String[] args) {
        // Wylosuję sobie liczbę:
        Random random = new Random();
        int x = random.nextInt(100) - 50; // liczba z zakresu od -50 do 49
        System.out.println("Wysolowana liczba: " + x);

        // podstawowa wersja if:
        if(x % 2 == 0) {
            System.out.println("liczba parzysta");
            System.out.println("Wynik dzielenia przez 2 = " + x / 2);
        } else {
            System.out.println("liczba nieparzysta");
        }

        // Gdy do wykonania jest tylko jedna instrukcja, można nie brać jej w {nawiasy klamrowe}
        // ale większośc ludzi powie "lepiej na wszelki wypadek {wziąć w nawiasy}"

        // Istnieje wersja if bez else:
        if(Math.abs(x % 10) == 7) {
            System.out.println("Ostatnią cyfrą jest 7");
        }

        // W Pythonie można używać słowa kluczowego elif, aby utworzyć ifa z wieloma gałęziami
        // W Javie zamiast tego używa się połączenie słów else if pisząc je w jednej linii:
        if(x > 0) {
            System.out.println("liczba dodatnia");
        } else if(x < 0) {
            System.out.println("liczba ujemna");
        } else {
            System.out.println("zero");
        }

        // W Pythonie jako warunek można przekazać liczbę, napis, listę, ...
        // Np. if lista:
        // będzie prawdą, jeśli lista jest niepusta

        // W Javie nie ma żadnych automatycznych konwersji innych typów na typ logiczny
//        if(x) {
//            System.out.println("W Pythonie i w C to by zadziałało, gdy x nie jest zerem");
//        }

        System.out.println();
        int y = random.nextInt(100) - 50;
        System.out.println("x: " + x + " , y: " + y);

        // spójniki logiczne
        // &&  czyli and, "i", koniunkcja
        if(x > 0 && y > 0) {
            System.out.println("Obie liczby są dodatnie");
        } else {
            System.out.println("Przynajmniej jedna z liczb nie jest dodatnia");
        }

        // ||  czyli or, "lub", alternatywa
        if(x > 0 || y > 0) {
            System.out.println("Co najmniej jedna z liczb jest dodatnia");
        } else {
            System.out.println("Żadna z liczb nie jest dodatnia");
        }

        // alternatywa rozłączna, "albo", "xor" zapisuje się ^
        // tego w praktyce się nie używa

        // negacja !
        String napis = "raz raz...";
        if(!napis.isEmpty()) {
            System.out.println("napis nie jest pusty");
        }
    }
}
